VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} ListSheets 
   Caption         =   "List of Sheets"
   ClientHeight    =   5772
   ClientLeft      =   108
   ClientTop       =   456
   ClientWidth     =   4572
   OleObjectBlob   =   "ListSheets.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "ListSheets"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public ws As Worksheet
Public iCnt As Integer
Public iCnt2 As Integer
Public iCol As Integer
Public iRow As Integer
Public SheetLastRow As Integer
Public SheetLastCol As Integer
Public ShowTheseRows As String
Public ShowTheseCols As String
Public printer_name As String
Public UsePrinter As String
Public RestPrinter As String
Public iPort As Boolean
Public HideIt As Boolean
Public GenHead As Boolean
Public HideMTRow As Boolean
Public HideMTCol As Boolean
Public FitWide As Boolean
Public FitTall As Boolean
Public UsePrint As Boolean
Public ReturnSheet As String
Public sComputer As String, I&
Public objWMIService As Object, objListPrinters As Object, objPrinter As Object
Private Sub lstPrinter_AfterUpdate()
printer_name = ""
For iCnt = 0 To lstPrinter.ListCount - 1
    If lstPrinter.Selected(iCnt) = True Then
        printer_name = lstPrinter.List(iCnt)
    End If
Next iCnt
End Sub
Private Sub chkWide_AfterUpdate()
If chkWide.Value = True Then
    FitWide = True
Else
    FitWide = False
End If
End Sub
Private Sub chkTall_AfterUpdate()
If chkTall.Value = True Then
    FitTall = True
Else
    FitTall = False
End If
End Sub
Private Sub chkDial_AfterUpdate()
If chkDial.Value = True Then
    ShowDial = True
Else
    ShowDial = False
End If
End Sub
Private Sub chkHead_AfterUpdate()
If chkHead.Value = True Then
    GenHead = True
Else
    GenHead = False
End If
End Sub
Private Sub chkMTCol_AfterUpdate()
If chkMTCol.Value = True Then
    HideMTCol = True
Else
    HideMTCol = False
End If
End Sub
Private Sub chkMTRow_AfterUpdate()
If chkMTRow.Value = True Then
    HideMTRow = True
Else
    HideMTRow = False
End If
End Sub
Private Sub chkOrient_AfterUpdate()
If chkOrient.Value = True Then
    iPort = False
Else
    iPort = True
End If
End Sub
Private Sub cmdCancel_Click()
frmPrint.Show vbApplicationModal
Unload Me
End Sub
Private Sub cmdPrint_Click()
Dim rng As Range
Dim y As Integer
Dim I As Variant
Application.ScreenUpdating = False
RestPrinter = Application.ActivePrinter
If printer_name <> "" Then
    UsePrinter = printer_name
Else
    UsePrinter = Application.ActivePrinter
End If
For iCnt = 0 To lstBox.ListCount - 1
    HideIt = False
    'Check ListBox Item has selcted or not
    If lstBox.Selected(iCnt) = True Then
        SelectedReport = lstBox.List(iCnt)
        With Sheets(SelectedReport)
            .Activate
            If iPort = True Then
                Worksheets(SelectedReport).PageSetup.Orientation = xlPortrait
            Else
                Worksheets(SelectedReport).PageSetup.Orientation = xlLandscape
            End If
            If HideMTRow = True Then
                ShowTheseRows = ""
                LastRow = .UsedRange.Rows.Count
                For X = 1 To LastRow
                    If Cells(X, Columns.Count).End(xlToLeft) = 0 Then
                        Rows(X).Hidden = True
                        ShowTheseRows = ShowTheseRows & X & " "
                    End If
                Next
            End If
            If HideMTCol = True Then
                LastCol = .UsedRange.Columns.Count
                ShowTheseCols = ""
                For y = 1 To LastCol
                    If ColumnEmpty(SelectedReport, y, True) = True Then
                        ShowTheseCols = ShowTheseCols & y & " "
                        .Range(Cells(y).Address(), Cells(y).Address()).EntireColumn.Hidden = True
                    End If
                Next y
            End If
            ThisWorkbook.Sheets(SelectedReport).Cells.EntireColumn.AutoFit
            Application.PrintCommunication = False
            If ThisWorkbook.Sheets(SelectedReport).Visible = xlSheetHidden Then
                HideIt = True
                ThisWorkbook.Sheets(SelectedReport).Visible = True
            End If
            If ThisWorkbook.Sheets(SelectedReport).Visible <> xlSheetVeryHidden Then
                If GenHead = True Then
                    With Sheets(SelectedReport).PageSetup
                        .FitToPagesWide = FitWide
                        .FitToPagesTall = FitTall
                        .LeftMargin = Application.InchesToPoints(0.25)
                        .RightMargin = Application.InchesToPoints(0.25)
                        .TopMargin = Application.InchesToPoints(0.75)
                        .BottomMargin = Application.InchesToPoints(0.75)
                        .CenterHeader = "&C&14&B" & SelectedReport
                        .RightFooter = Format(Now, "MMMM DD, YYYY HH:MM:SS")
                        .CenterFooter = "Page &P of &N"
                        .PrintTitleRows = "$1:$1"
                   ThisWorkbook.Sheets(SelectedReport).PrintOut Preview:=False, ActivePrinter:=UsePrinter, PrintToFile:=True, PrToFileName:=PSFileName
                  '  ThisWorkbook.Sheets(SelectedReport).PrintOut
                    End With
                Else
            ThisWorkbook.Sheets(SelectedReport).PrintOut Preview:=False, ActivePrinter:=UsePrinter, PrintToFile:=True, PrToFileName:=PSFileName
               ' ThisWorkbook.Sheets(SelectedReport).PrintOut
                End If
            End If
            If HideIt = True Then
                ThisWorkbook.Sheets(SelectedReport).Visible = xlSheetHidden
            End If
            Application.PrintCommunication = True
            If ShowTheseRows <> "" Then
                ShowTheseRows = Left(ShowTheseRows, Len(ShowTheseRows) - 1)
                MyArray = Split(ShowTheseRows)
                For Each I In MyArray
                    Rows(I).Hidden = False
                Next I
            End If
            If ShowTheseCols <> "" Then
                ShowTheseCols = Left(ShowTheseCols, Len(ShowTheseCols) - 1)
                MyArray = Split(ShowTheseCols)
                For Each I In MyArray
                    .Range(Cells(I).Address(), Cells(I).Address()).EntireColumn.Hidden = False
                Next I
            End If
            ActiveWindow.View = xlNormalView
            ThisWorkbook.Sheets(SelectedReport).Cells.EntireColumn.AutoFit
        End With
    End If
Next
Application.ActivePrinter = RestPrinter
ThisWorkbook.Sheets(ReturnSheet).Activate
Application.ScreenUpdating = True
End Sub
Private Sub UserForm_Initialize()
ReturnSheet = ActiveSheet.Name
iCnt = 0
iCnt2 = 0
lstBox.Clear
lstPrinter.Clear
HideMTRow = False
HideMTCol = False
FitTall = False
FitWide = False
GenHead = False
iPort = True
For Each ws In ThisWorkbook.Sheets
    lstBox.AddItem
    lstBox.List(iCnt, 0) = ws.Name
    If ws.Visible = xlSheetHidden Then
        lstBox.List(iCnt, 1) = "Hidden"
    End If
    If ws.Visible = xlSheetVeryHidden Then
        lstBox.List(iCnt, 1) = "Very Hidden"
    End If
    iCnt = iCnt + 1
Next ws
For I = 0 To lstBox.ListCount - 2
    For j = I + 1 To lstBox.ListCount - 1
        If lstBox.List(I) > lstBox.List(j) Then
            Temp = lstBox.List(j)
            lstBox.List(j) = lstBox.List(I)
            lstBox.List(I) = Temp
        End If
    Next j
Next I
sComputer = "."
Set objWMIService = GetObject("winmgmts:" _
                    & "{impersonationLevel=impersonate}!\\" & sComputer & "\root\cimv2")
Set objListPrinters = objWMIService.ExecQuery _
                               ("Select * from Win32_Printer")
For Each objPrinter In objListPrinters
    lstPrinter.AddItem
    lstPrinter.List(iCnt2, 0) = objPrinter.Name
    iCnt2 = iCnt2 + 1
Next
End Sub
Private Sub UserForm_Terminate()
frmPrint.Show vbApplicationModal
End Sub

